/*********************************************************************************************************************
 * CH32V307VCT6 Opensourec Library CH32V307VCT6 Դ⣩һڹٷ SDK ӿڵĵԴ
 * Copyright (c) 2022 SEEKFREE ɿƼ
 *
 * ļCH32V307VCT6 Դһ
 *
 * CH32V307VCT6 Դ 
 * Ըᷢ GPLGNU General Public License GNUͨù֤
 *  GPL ĵ3棨 GPL3.0ѡģκκİ汾·/޸
 *
 * Դķϣܷãδκεı֤
 * ûԻʺض;ı֤
 * ϸμ GPL
 *
 * ӦյԴͬʱյһ GPL ĸ
 * ûУ<https://www.gnu.org/licenses/>
 *
 * ע
 * Դʹ GPL3.0 Դ֤Э Ϊİ汾
 * Ӣİ libraries/doc ļµ GPL3_permission_statement.txt ļ
 * ֤ libraries ļ ļµ LICENSE ļ
 * ӭλʹò ޸ʱ뱣ɿƼİȨ
 *
 * ļ          zf_common_clock
 * ˾          ɶɿƼ޹˾
 * 汾Ϣ          鿴 libraries/doc ļ version ļ 汾˵
 *           MounRiver Studio V1.8.1
 * ƽ̨          CH32V307VCT6
 *           https://seekfree.taobao.com/
 *
 * ޸ļ¼
 *                                                                    ע
 * 2022-09-15        W            first version
 ********************************************************************************************************************/

#include "ch32v30x.h"
#include "zf_common_function.h"
#include "zf_common_interrupt.h"

#include "zf_common_clock.h"

uint32 system_clock = SYSTEM_CLOCK_144M;                               // ϵͳʱϢ

//-------------------------------------------------------------------------------------------------------------------
//       ʱӻָʼ ڲ
// ˵     void
// ز     void
//-------------------------------------------------------------------------------------------------------------------
void clock_reset(void)
{
    RCC->CTLR  |= (uint32) 0x00000001;      //ʹHSI
    RCC->CFGR0 &= (uint32) 0xF8FF0000;
    RCC->CTLR  &= (uint32) 0xFEF6FFFF;
    RCC->CTLR  &= (uint32) 0xFFFBFFFF;
    RCC->CFGR0 &= (uint32) 0xFF80FFFF;
    RCC->INTR   = (uint32) 0x009F0000;      // жϲλ
}

//-------------------------------------------------------------------------------------------------------------------
//       ʱ
// ˵     clock           ʱƵ Ƽʹ zf_common_clock.h  system_clock_enum ѡ
// ز     void
//-------------------------------------------------------------------------------------------------------------------
void clock_set_freq(uint32 clock)
{
    clock_reset();
    __IO uint32_t StartUpCounter = 0, HSEStatus = 0;

    RCC->CTLR |= ((uint32_t) RCC_HSEON);

    /* Wait till HSE is ready and if Time out is reached exit */
    do {
        HSEStatus = RCC->CTLR & RCC_HSERDY;
        StartUpCounter++;
    } while ((HSEStatus == 0) && (StartUpCounter != HSE_STARTUP_TIMEOUT));

    if ((RCC->CTLR & RCC_HSERDY) != RESET)
    {
        HSEStatus = (uint32_t) 0x01;
    }
    else
    {
        HSEStatus = (uint32_t) 0x00;
    }

    if (HSEStatus == (uint32_t) 0x01)
    {

//        /* Enable Prefetch Buffer */
//        FLASH->ACTLR |= FLASH_ACTLR_PRFTBE; ((uint8_t)0x10)
//
//        /* Flash 2 wait state */
//        FLASH->ACTLR &= (uint32_t)((uint32_t)~FLASH_ACTLR_LATENCY);   ((uint8_t)0x03)
//        FLASH->ACTLR |= (uint32_t)FLASH_ACTLR_LATENCY_2;              ((uint8_t)0x02)

        /* HCLK = SYSCLK */
        RCC->CFGR0 |= (uint32_t) RCC_HPRE_DIV1;
        /* PCLK2 = HCLK */
        RCC->CFGR0 |= (uint32_t) RCC_PPRE2_DIV1;
        /* PCLK1 = HCLK */
        RCC->CFGR0 |= (uint32_t) RCC_PPRE1_DIV1;

        /*  PLL configuration: PLLCLK = HSE * ? = ? MHz */
        RCC->CFGR0 &= (uint32) ((uint32) ~(RCC_PLLSRC | RCC_PLLXTPRE
                | RCC_PLLMULL));

        if (clock == SYSTEM_CLOCK_144M)
            RCC->CFGR0 |= (uint32) (RCC_PLLSRC_HSE | RCC_PLLXTPRE_HSE
                    | RCC_PLLMULL18_EXTEN);
        else if (clock == SYSTEM_CLOCK_120M)
            RCC->CFGR0 |= (uint32) (RCC_PLLSRC_HSE | RCC_PLLXTPRE_HSE
                    | RCC_PLLMULL15_EXTEN);
        else if (clock == SYSTEM_CLOCK_96M)
            RCC->CFGR0 |= (uint32) (RCC_PLLSRC_HSE | RCC_PLLXTPRE_HSE
                    | RCC_PLLMULL12_EXTEN);
        else if (clock == SYSTEM_CLOCK_72M)
            RCC->CFGR0 |= (uint32) (RCC_PLLSRC_HSE | RCC_PLLXTPRE_HSE
                    | RCC_PLLMULL9_EXTEN);
        else if (clock == SYSTEM_CLOCK_48M)
            RCC->CFGR0 |= (uint32) (RCC_PLLSRC_HSE | RCC_PLLXTPRE_HSE
                    | RCC_PLLMULL6_EXTEN);
        else if (clock == SYSTEM_CLOCK_24M)
            RCC->CFGR0 |= (uint32) (RCC_PLLSRC_HSE | RCC_PLLXTPRE_HSE
                    | RCC_PLLMULL3_EXTEN);

        /* Enable PLL */
        RCC->CTLR |= RCC_PLLON;
        /* Wait till PLL is ready */
        while((RCC->CTLR & RCC_PLLRDY) == 0)
        {
        }
        /* Select PLL as system clock source */
        RCC->CFGR0 &= (uint32_t) ((uint32_t) ~(RCC_SW));
        RCC->CFGR0 |= (uint32_t) RCC_SW_PLL;
        /* Wait till PLL is used as system clock source */
        while ((RCC->CFGR0 & (uint32_t)RCC_SWS) != (uint32_t)0x08)
        {
        }
    }
    else
    {
        while(1);
        // ⲿȶȱʧ ʱʧ
        /*
         * If HSE fails to start-up, the application will have wrong clock
         * configuration. User can add here some code to deal with this error
         */
    }
}

//-------------------------------------------------------------------------------------------------------------------
//       ʱӳʼ
// ˵     clock           ʱƵ Ƽʹ zf_common_clock.h  system_clock_enum ѡ
// ز     void
// ʹʾ     clock_init(SYSTEM_CLOCK_144M);                   // ʼʱΪ 144MHz
//-------------------------------------------------------------------------------------------------------------------
void clock_init(uint32 clock)
{

    system_clock = clock;                                            // ¼ʱƵ
    clock_reset();
    clock_set_freq(clock);

    interrupt_init();
}
