/*********************************************************************************************************************
* CH32V307VCT6 Opensourec Library CH32V307VCT6 Դ⣩һڹٷ SDK ӿڵĵԴ
* Copyright (c) 2022 SEEKFREE ɿƼ
*
* ļCH32V307VCT6 Դһ
*
* CH32V307VCT6 Դ 
* Ըᷢ GPLGNU General Public License GNUͨù֤
*  GPL ĵ3棨 GPL3.0ѡģκκİ汾·/޸
*
* Դķϣܷãδκεı֤
* ûԻʺض;ı֤
* ϸμ GPL
*
* ӦյԴͬʱյһ GPL ĸ
* ûУ<https://www.gnu.org/licenses/>
*
* ע
* Դʹ GPL3.0 Դ֤Э Ϊİ汾
* Ӣİ libraries/doc ļµ GPL3_permission_statement.txt ļ
* ֤ libraries ļ ļµ LICENSE ļ
* ӭλʹò ޸ʱ뱣ɿƼİȨ
*
* ļ          zf_device_k24c02
* ˾          ɶɿƼ޹˾
* 汾Ϣ          鿴 libraries/doc ļ version ļ 汾˵
*           MounRiver Studio V1.8.1
* ƽ̨          CH32V307VCT6
*           https://seekfree.taobao.com/
*
* ޸ļ¼
*                                                                    ע
* 2022-09-15        W            first version
********************************************************************************************************************/
/*********************************************************************************************************************
* ߶壺
*                   ------------------------------------
*                   ģܽ                                        Ƭܽ
*                    IIC ͨŶӦϵ
*                   SCL                 鿴 zf_device_k24c02.h  K24C02_SCL_PIN 궨
*                   SDA                 鿴 zf_device_k24c02.h  K24C02_SDA_PIN 궨
*                   Ӳ IIC ͨŶӦϵ
*                   SCL                 鿴 zf_device_k24c02.h  K24C02_SCL_PIN 궨
*                   SDA                 鿴 zf_device_k24c02.h  K24C02_SDA_PIN 궨
*                   ------------------------------------
********************************************************************************************************************/

#include "zf_common_clock.h"
#include "zf_common_debug.h"
#include "zf_driver_delay.h"
#include "zf_driver_iic.h"
#include "zf_driver_soft_iic.h"

#include "zf_device_k24c02.h"

#if K24C02_USE_SOFT_IIC
static soft_iic_info_struct k24c02_iic_struct;

//-------------------------------------------------------------------------------------------------------------------
//      K24C02 IIC дĴ
// ˵     reg             Ĵ
// ˵     *data           ݻ
// ˵     len             ݳ
// ز     void
// ʹʾ     k24c02_write_registers(page_num*8, (uint8 *)&k24c02_union_buffer[0], K24C02_PAGE_SIZE);
// עϢ     ڲ
//-------------------------------------------------------------------------------------------------------------------
#define k24c02_write_registers(reg, data, len)  (soft_iic_write_8bit_registers(&k24c02_iic_struct, (reg), (data), (len)))

//-------------------------------------------------------------------------------------------------------------------
//      K24C02 IIC Ĵ
// ˵     reg             Ĵ
// ˵     *data           ݻ
// ˵     len             ݳ
// ز     void
// ʹʾ     k24c02_read_registers(page_num*8, (uint8 *)&k24c02_union_buffer[0], K24C02_PAGE_SIZE);
// עϢ     ڲ
//-------------------------------------------------------------------------------------------------------------------
#define k24c02_read_registers(reg, data, len)   (soft_iic_read_8bit_registers(&k24c02_iic_struct, (reg), (data), (len)))
#else
//-------------------------------------------------------------------------------------------------------------------
//      K24C02 IIC дĴ
// ˵     reg             Ĵ
// ˵     *data           ݻ
// ˵     len             ݳ
// ز     void
// ʹʾ     k24c02_write_registers(page_num*8, (uint8 *)&k24c02_union_buffer[0], K24C02_PAGE_SIZE);
// עϢ     ڲ
//-------------------------------------------------------------------------------------------------------------------
#define k24c02_write_registers(reg, data, len)  (iic_write_8bit_registers(K24C02_IIC, K24C02_DEV_ADDR, (reg), (data), (len)))

//-------------------------------------------------------------------------------------------------------------------
//      K24C02 IIC Ĵ
// ˵     reg             Ĵ
// ˵     *data           ݻ
// ˵     len             ݳ
// ز     void
// ʹʾ     k24c02_read_registers(page_num*8, (uint8 *)&k24c02_union_buffer[0], K24C02_PAGE_SIZE);
// עϢ     ڲ
//-------------------------------------------------------------------------------------------------------------------
#define k24c02_read_registers(reg, data, len)   (iic_read_8bit_registers(K24C02_IIC, K24C02_DEV_ADDR, (reg), (data), (len)))
#endif

k24c02_data_union k24c02_union_buffer[K24C02_DATA_BUFFER_SIZE];

//-------------------------------------------------------------------------------------------------------------------
//      K24C02 ָҳݵ
// ˵     page_num        ָҳ
// ز     void
// ʹʾ     k24c02_read_page_to_buffer(K24C02_PAGE_0);
// עϢ     ݸµ ñֱӶȡ
//-------------------------------------------------------------------------------------------------------------------
void k24c02_read_page_to_buffer (k24c02_page_enum page_num)
{
    k24c02_read_registers(page_num*8, (uint8 *)&k24c02_union_buffer[0], K24C02_PAGE_SIZE);
}

//-------------------------------------------------------------------------------------------------------------------
//      K24C02 дָҳ
// ˵     page_num        ָҳ
// ز     void
// ʹʾ     k24c02_write_page_from_buffer(K24C02_PAGE_0);
// עϢ     ݻд K24C02 ָҳ
//-------------------------------------------------------------------------------------------------------------------
uint8 k24c02_write_page_from_buffer (k24c02_page_enum page_num)
{
    uint8 return_state = 0;
    k24c02_write_registers(page_num*8, (uint8 *)&k24c02_union_buffer[0], K24C02_PAGE_SIZE);
    return return_state;
}

//-------------------------------------------------------------------------------------------------------------------
// brief		ʼ K24C02
// param		void
// return		uint8           1-ʼʧ 0-ʼɹ
// ʹʾ     k24c02_init();
// עϢ     
//-------------------------------------------------------------------------------------------------------------------
uint8 k24c02_init (void)
{
    uint8 return_state = 0;
#if K24C02_USE_SOFT_IIC
    soft_iic_init(&k24c02_iic_struct, K24C02_DEV_ADDR, K24C02_SOFT_IIC_DELAY, K24C02_SCL_PIN, K24C02_SDA_PIN);
#else
    iic_init(K24C02_IIC, K24C02_DEV_ADDR, K24C02_IIC_SPEED, K24C02_SCL_PIN, K24C02_SDA_PIN);
#endif
    return return_state;
}
