/*********************************************************************************************************************
* CH32V307VCT6 Opensourec Library CH32V307VCT6 Դ⣩һڹٷ SDK ӿڵĵԴ
* Copyright (c) 2022 SEEKFREE ɿƼ
*
* ļCH32V307VCT6 Դһ
*
* CH32V307VCT6 Դ 
* Ըᷢ GPLGNU General Public License GNUͨù֤
*  GPL ĵ3棨 GPL3.0ѡģκκİ汾·/޸
*
* Դķϣܷãδκεı֤
* ûԻʺض;ı֤
* ϸμ GPL
*
* ӦյԴͬʱյһ GPL ĸ
* ûУ<https://www.gnu.org/licenses/>
*
* ע
* Դʹ GPL3.0 Դ֤Э Ϊİ汾
* Ӣİ libraries/doc ļµ GPL3_permission_statement.txt ļ
* ֤ libraries ļ ļµ LICENSE ļ
* ӭλʹò ޸ʱ뱣ɿƼİȨ
*
* ļ          zf_device_wireless_ch573
* ˾          ɶɿƼ޹˾
* 汾Ϣ          鿴 libraries/doc ļ version ļ 汾˵
*           MounRiver Studio V1.8.1
* ƽ̨          CH32V307VCT6
*           https://seekfree.taobao.com/
*
* ޸ļ¼
*                                                                    ע
* 2022-09-15        W            first version
********************************************************************************************************************/
/*********************************************************************************************************************
* ߶壺
*                   ------------------------------------
*                   ģܽ                                 Ƭܽ
*                   RX                  鿴 zf_device_wireless_ch573.h  WIRELESS_CH573_RX_PIN  궨
*                   TX                  鿴 zf_device_wireless_ch573.h  WIRELESS_CH573_TX_PIN  궨
*                   RTS                 鿴 zf_device_wireless_ch573.h  WIRELESS_CH573_RTS_PIN 궨
*                   VCC                 5V Դ
*                   GND                 Դ
*                   
*                   ------------------------------------
*********************************************************************************************************************/

#include "zf_common_fifo.h"
#include "zf_device_type.h"
#include "zf_device_wireless_ch573.h"

static  fifo_struct       wireless_ch573_fifo;
static  uint8             wireless_ch573_buffer[WIRELESS_CH573_BUFFER_SIZE];                                // Ӧһ ߴ ݴ

static  uint8             wireless_ch573_data;

//-------------------------------------------------------------------------------------------------------------------
//       CH573ģжϻص
// ˵     void
// ز     void
// Sample usage:
// @note
//-------------------------------------------------------------------------------------------------------------------
void wireless_ch573_callback (void)
{
    uart_query_byte(WIRELESS_CH573_INDEX, &wireless_ch573_data);
    fifo_write_buffer(&wireless_ch573_fifo, &wireless_ch573_data, 1);

}


//-------------------------------------------------------------------------------------------------------------------
//       תģ 
// ˵     data            8bit 
// ز     uint32          ʣ෢ͳ
// Sample usage:
//-------------------------------------------------------------------------------------------------------------------
uint32 wireless_ch573_send_byte (const uint8 data)
{
    uint16 time_count = 0;
    while(gpio_get_level(WIRELESS_CH573_RTS_PIN))                                      // RTSΪ͵ƽ
    {
        if(time_count++ > WIRELESS_CH573_TIMEOUT_COUNT)
            return 1;                                                           // ģæ,ǰʹwhileȴ ʹúע͵whileȴ滻if
        system_delay_ms(1);
    }
    uart_write_byte(WIRELESS_CH573_INDEX, data);                                 // 

    return 0;
}

//-------------------------------------------------------------------------------------------------------------------
//       CH573ģ ڷ
// ˵     buff            ݵַ
// ˵     len             ݳ
// ز     uint32        ʾϢ
// Sample usage:
// @note
//-------------------------------------------------------------------------------------------------------------------
uint32 wireless_ch573_send_buff (const uint8 *buff, uint32 len)
{
    uint16 time_count = 0;
    uint8 pack_len = 62;
    while(len > pack_len)
    {
        time_count = 0;
        while(gpio_get_level(WIRELESS_CH573_RTS_PIN) && time_count++ < WIRELESS_CH573_TIMEOUT_COUNT)  // RTSΪ͵ƽ
            system_delay_ms(1);
        if(time_count >= WIRELESS_CH573_TIMEOUT_COUNT)
            return len;                                                                             // ģæ,ǰʹwhileȴ ʹúע͵whileȴ滻if
        uart_write_buffer(WIRELESS_CH573_INDEX, buff, 30);

        buff += pack_len;                                                                           // ַƫ
        len -= pack_len;                                                                            // 
    }

    time_count = 0;
    while(gpio_get_level(WIRELESS_CH573_RTS_PIN) && time_count++ < WIRELESS_CH573_TIMEOUT_COUNT)  // RTSΪ͵ƽ
        system_delay_ms(1);
    if(time_count >= WIRELESS_CH573_TIMEOUT_COUNT)
        return len;                                                                                 // ģæ,ǰʹwhileȴ ʹúע͵whileȴ滻if
    uart_write_buffer(WIRELESS_CH573_INDEX, buff, len);                                            // 

    return 0;
}

//-------------------------------------------------------------------------------------------------------------------
//       CH573ģ ڽ
// ˵     buff            ݵַ
// ˵     len             ݳ
// ز     void
// Sample usage:
// @note
//-------------------------------------------------------------------------------------------------------------------
uint32 wireless_ch573_read_buff (uint8 *buff, uint32 len)
{
    uint32 data_len = len;
    fifo_read_buffer(&wireless_ch573_fifo, buff, &data_len, FIFO_READ_AND_CLEAN);
    return data_len;
}


//-------------------------------------------------------------------------------------------------------------------
//       תģ ͷͼλ鿴ͼ
// ˵     *image_addr     Ҫ͵ͼַ
// ˵     image_size      ͼĴС
// ز     void
// ʹʾ     wireless_uart_send_image(&mt9v03x_image[0][0], MT9V03X_IMAGE_SIZE);
//-------------------------------------------------------------------------------------------------------------------
void wireless_ch573_send_image (const uint8 *image_addr, uint32 image_size)
{
    extern uint8 camera_send_image_frame_header[4];
    wireless_ch573_send_buff(camera_send_image_frame_header, 4);
    wireless_ch573_send_buff((uint8 *)image_addr, image_size);
}

//-------------------------------------------------------------------------------------------------------------------
//       CH573ģʼ
// ˵     void
// ز     void
// Sample usage:
// @note
//-------------------------------------------------------------------------------------------------------------------
uint8 wireless_ch573_init (void)
{

    set_wireless_type(WIRELESS_CH573, wireless_ch573_callback);



    fifo_init(&wireless_ch573_fifo, FIFO_DATA_8BIT, wireless_ch573_buffer, WIRELESS_CH573_BUFFER_SIZE);
    gpio_init(WIRELESS_CH573_RTS_PIN, GPI, GPIO_HIGH, GPI_PULL_UP);

    uart_init (WIRELESS_CH573_INDEX, WIRELESS_CH573_BUAD_RATE, WIRELESS_CH573_RX_PIN, WIRELESS_CH573_TX_PIN);
    uart_rx_interrupt(WIRELESS_CH573_INDEX, 1);

    return 0;
}



