/*********************************************************************************************************************
* CH32V307VCT6 Opensourec Library CH32V307VCT6 Դ⣩һڹٷ SDK ӿڵĵԴ
* Copyright (c) 2022 SEEKFREE ɿƼ
*
* ļCH32V307VCT6 Դһ
*
* CH32V307VCT6 Դ 
* Ըᷢ GPLGNU General Public License GNUͨù֤
*  GPL ĵ3棨 GPL3.0ѡģκκİ汾·/޸
*
* Դķϣܷãδκεı֤
* ûԻʺض;ı֤
* ϸμ GPL
*
* ӦյԴͬʱյһ GPL ĸ
* ûУ<https://www.gnu.org/licenses/>
*
* ע
* Դʹ GPL3.0 Դ֤Э Ϊİ汾
* Ӣİ libraries/doc ļµ GPL3_permission_statement.txt ļ
* ֤ libraries ļ ļµ LICENSE ļ
* ӭλʹò ޸ʱ뱣ɿƼİȨ
*
* ļ          zf_driver_adc
* ˾          ɶɿƼ޹˾
* 汾Ϣ          鿴 libraries/doc ļ version ļ 汾˵
*           MounRiver Studio V1.8.1
* ƽ̨          CH32V307VCT6
*           https://seekfree.taobao.com/
*
* ޸ļ¼
*                                                                    ע
* 2022-09-15        W            first version
********************************************************************************************************************/

#include "ch32v30x.h"
#include "ch32v30x_adc.h"

#include "zf_driver_adc.h"
#include "zf_driver_gpio.h"

#include "zf_common_debug.h"


static  ADC_TypeDef    *adc_index[2]        = {ADC1, ADC2};
static  uint8           adc_resolution[2]   = {ADC_12BIT, ADC_12BIT};


//-------------------------------------------------------------------------------------------------------------------
//      ADCתһ
// ˵     ch              ѡADCͨ
// ˵     resolution      ֱ(8λ 10λ 12λ)
// ز     void
// ʹʾ     adc_convert(ADC_IN0_A0, ADC_8BIT);  //ɼA0˿ڷ8λֱʵADֵ
//-------------------------------------------------------------------------------------------------------------------
uint16 adc_convert (adc_channel_enum ch)
{
    uint8 adc = ((ch & 0xF000) >> 12);
    uint8 adc_ch = (uint8)(ch >> 8) & 0xF;

    ADC_RegularChannelConfig(adc_index[adc], adc_ch, 1, ADC_SampleTime_41Cycles5);  // ʹܶӦͨ
    ADC_SoftwareStartConvCmd(adc_index[adc], ENABLE);                               // ʼת
    while(!ADC_GetFlagStatus(adc_index[adc], ADC_FLAG_EOC ));                       // ȴת
    return ((adc_index[adc]->RDATAR) >> adc_resolution[adc]);                       // ȡ
}

//-------------------------------------------------------------------------------------------------------------------
//      ADCתNΣƽֵ˲
// ˵     ch              ѡADCͨ
// ˵     resolution      ֱ(8λ 10λ 12λ)
// ˵     count           ת
// ز     void
// ʹʾ     adc_mean_filter(ADC_IN0_A0, ADC_8BIT,5);  //ɼA0˿ڷ8λֱʵADֵɼȡƽֵ
//-------------------------------------------------------------------------------------------------------------------
uint16 adc_mean_filter_convert (adc_channel_enum ch, const uint8 count)
{
    uint8 i;
    uint32 sum;

    zf_assert(count);//ԴΪ0

    sum = 0;
    for(i=0; i<count; i++)
    {
        sum += adc_convert(ch);
    }

    sum = sum/count;
    return sum;
}

//-------------------------------------------------------------------------------------------------------------------
//      ADCʼ
// ˵     adc_ch      adc_chͨ(ѡΧzf_adc.hADC_CH_enumöֵȷ)
// ز     void
// ʹʾ    adc_init(ADC_IN0_A0);//ʼA0ΪADC
//-------------------------------------------------------------------------------------------------------------------
void adc_init (adc_channel_enum ch, adc_resolution_enum resolution)
{
    ADC_InitTypeDef ADC_InitStructure = {0};

    uint8 adc = ((ch & 0xF000) >> 12);
    gpio_init(ch&0xFF, GPI, 0, GPI_ANAOG_IN);                           // GPIOʼ

    if(adc == 0)
    {
        RCC_APB2PeriphClockCmd(RCC_APB2Periph_ADC1 , ENABLE );          // ʹADC1ͨʱ
    }
    else if(adc == 1)
    {
        RCC_APB2PeriphClockCmd(RCC_APB2Periph_ADC2 , ENABLE );          // ʹADC2ͨʱ
    }

    RCC_ADCCLKConfig(RCC_PCLK2_Div8);


//    if(system_clock > 84000000)  RCC_ADCCLKConfig(RCC_PCLK2_Div8);    // ADCƵӣADCʲܳ14M
//    else RCC_ADCCLKConfig(RCC_PCLK2_Div6);

    ADC_DeInit(adc_index[adc]);
    ADC_InitStructure.ADC_Mode = ADC_Mode_Independent;                  // ADCģʽ:ADC1ڶģʽ
    ADC_InitStructure.ADC_ScanConvMode = DISABLE;                       // ģתڵͨģʽ
    ADC_InitStructure.ADC_ContinuousConvMode = DISABLE;                 // ģתڵתģʽ
    ADC_InitStructure.ADC_ExternalTrigConv = ADC_ExternalTrigConv_None; // תⲿ
    ADC_InitStructure.ADC_DataAlign = ADC_DataAlign_Right;              // ADCҶ
    ADC_InitStructure.ADC_NbrOfChannel = 1;                             // ˳йתADCͨĿ
    ADC_Init(adc_index[adc], &ADC_InitStructure);                       // ADC_InitStructָĲʼADCxļĴ

    ADC_Cmd(adc_index[adc], ENABLE);                                    // ʹָADC1
    ADC_BufferCmd(adc_index[adc], DISABLE);                             // disable buffer

    ADC_ResetCalibration(adc_index[adc]);                               // ʹܸλУ׼
    while(ADC_GetResetCalibrationStatus(adc_index[adc]));               // ȴλУ׼
    ADC_StartCalibration(adc_index[adc]);                               // ADУ׼
    while(ADC_GetCalibrationStatus(adc_index[adc]));                    // ȴУ׼
    //ADC_BufferCmd(ADC1, ENABLE);                                      // enable buffer

    adc_resolution[adc] = resolution;                                   // ¼ADC ڲɼʱʹ
}
