/*********************************************************************************************************************
* CH32V307VCT6 Opensourec Library CH32V307VCT6 Դ⣩һڹٷ SDK ӿڵĵԴ
* Copyright (c) 2022 SEEKFREE ɿƼ
*
* ļCH32V307VCT6 Դһ
*
* CH32V307VCT6 Դ 
* Ըᷢ GPLGNU General Public License GNUͨù֤
*  GPL ĵ3棨 GPL3.0ѡģκκİ汾·/޸
*
* Դķϣܷãδκεı֤
* ûԻʺض;ı֤
* ϸμ GPL
*
* ӦյԴͬʱյһ GPL ĸ
* ûУ<https://www.gnu.org/licenses/>
*
* ע
* Դʹ GPL3.0 Դ֤Э Ϊİ汾
* Ӣİ libraries/doc ļµ GPL3_permission_statement.txt ļ
* ֤ libraries ļ ļµ LICENSE ļ
* ӭλʹò ޸ʱ뱣ɿƼİȨ
*
* ļ          zf_driver_delay
* ˾          ɶɿƼ޹˾
* 汾Ϣ          鿴 libraries/doc ļ version ļ 汾˵
*           MounRiver Studio V1.8.1
* ƽ̨          CH32V307VCT6
*           https://seekfree.taobao.com/
*
* ޸ļ¼
*                                                                    ע
* 2022-09-15        W            first version
********************************************************************************************************************/

#include "zf_driver_delay.h"

/**************************˶**************************/
volatile uint32_t sysTickUptime = 0;
void SysTick_init(void)
{
    SysTick->SR &= ~(1 << 0);//clear State flag
    SysTick->CMP = (uint64_t)(system_clock/1000);
    SysTick->CNT = 0;

    interrupt_set_priority(SysTicK_IRQn, 15);
    interrupt_enable(SysTicK_IRQn);

    SysTick->CTLR = 0x3F;
}

uint64_t GetSysTime_us(void)
{
    register uint64_t ms;
    uint64_t value;
    do
    {
        ms = sysTickUptime;
        value = (ms * SysTick->CMP + (SysTick->CMP - SysTick->CNT))/(system_clock/1000000);
    }
    while(ms != sysTickUptime);
    return value;
}

u32 SysTick_GetTick(void)
{
    return sysTickUptime;
}

void SysTick_Handler(void) __attribute__((interrupt()));
void SysTick_Handler(void)
{
    if (SysTick->SR == 1) {
        sysTickUptime++;
        SysTick->SR = 0;
    }
}


/**************************˶**************************/

#if SELF_DELAY

/**************************ع**************************/
void system_delay_us (uint32 num)
{
    uint32_t now = GetSysTime_us();
    while(GetSysTime_us() - now < num);
}

void system_delay_ms (uint32 num)
{
    while(num--)system_delay_us(1000);
}
/**************************ع**************************/

#else

//-------------------------------------------------------------------------------------------------------------------
//      system ʱ ms 
// ˵     time            Ҫʱʱ ms 
// ز     void
// ʹʾ     system_delay_ms(100);
// עϢ
//-------------------------------------------------------------------------------------------------------------------
void system_delay_ms (uint32 num)
{
    SysTick->SR &= ~(1 << 0);


    SysTick->CMP = (uint64_t)(system_clock/8000) * num;
    SysTick->CTLR |= (1 << 4);
    SysTick->CTLR |= (1 << 5) | (1 << 0);

    while((SysTick->SR & (1 << 0)) != (1 << 0));

    SysTick->CTLR &= ~(1 << 0);
}

//-------------------------------------------------------------------------------------------------------------------
//      system ʱ us 
// ˵     time            Ҫʱʱ us 
// ز     void
// ʹʾ     system_delay_us(100);
// עϢ     ڳת ʱֵ߳һЩ
//-------------------------------------------------------------------------------------------------------------------
void system_delay_us (uint32 num)
{
    SysTick->SR &= ~(1 << 0);


    SysTick->CMP = (uint64_t)(system_clock/8000000) * num;
    SysTick->CTLR |= (1 << 4);
    SysTick->CTLR |= (1 << 5) | (1 << 0);

    while((SysTick->SR & (1 << 0)) != (1 << 0));

    SysTick->CTLR &= ~(1 << 0);
}

#endif
