/*********************************************************************************************************************
* CH32V307VCT6 Opensourec Library CH32V307VCT6 Դ⣩һڹٷ SDK ӿڵĵԴ
* Copyright (c) 2022 SEEKFREE ɿƼ
*
* ļCH32V307VCT6 Դһ
*
* CH32V307VCT6 Դ 
* Ըᷢ GPLGNU General Public License GNUͨù֤
*  GPL ĵ3棨 GPL3.0ѡģκκİ汾·/޸
*
* Դķϣܷãδκεı֤
* ûԻʺض;ı֤
* ϸμ GPL
*
* ӦյԴͬʱյһ GPL ĸ
* ûУ<https://www.gnu.org/licenses/>
*
* ע
* Դʹ GPL3.0 Դ֤Э Ϊİ汾
* Ӣİ libraries/doc ļµ GPL3_permission_statement.txt ļ
* ֤ libraries ļ ļµ LICENSE ļ
* ӭλʹò ޸ʱ뱣ɿƼİȨ
*
* ļ          zf_driver_encoder
* ˾          ɶɿƼ޹˾
* 汾Ϣ          鿴 libraries/doc ļ version ļ 汾˵
*           MounRiver Studio V1.8.1
* ƽ̨          CH32V307VCT6
*           https://seekfree.taobao.com/
*
* ޸ļ¼
*                                                                    ע
* 2022-09-15        W            first version
********************************************************************************************************************/

#include "zf_driver_gpio.h"
#include "zf_driver_timer.h"
#include "zf_driver_encoder.h"


static volatile uint8 encoder_dir_pin[10] = { 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
                                            0xFF, 0xFF, 0xFF, 0xFF, 0xFF};

//-------------------------------------------------------------------------------------------------------------------
//      ʱȡֵ
// ˵     timer_ch      ʱö
// ز     void
// עϢ
// ʹʾ    encoder_get_count(TIM2_ENCOEDER)  // ȡʱ2Ĳɼı
//-------------------------------------------------------------------------------------------------------------------
int16 encoder_get_count(encoder_index_enum encoder_n)
{
    int16 result = 0;
    int16 return_value = 0;
    switch(encoder_n)
    {
        case TIM1_ENCOEDER:  result = TIM1->CNT;   break;
        case TIM2_ENCOEDER:  result = TIM2->CNT;   break;
        case TIM3_ENCOEDER:  result = TIM3->CNT;   break;
        case TIM4_ENCOEDER:  result = TIM4->CNT;   break;
        case TIM5_ENCOEDER:  result = TIM5->CNT;   break;
        case TIM8_ENCOEDER:  result = TIM8->CNT;   break;
        case TIM9_ENCOEDER:  result = TIM9->CNT;   break;
        case TIM10_ENCOEDER: result = TIM10->CNT;  break;
        default:             result = 0;                 break;
    }
    if(0xFF == encoder_dir_pin[encoder_n])
    {
        return_value = result;
    }
    else
    {
        if(!gpio_get_level((gpio_pin_enum)encoder_dir_pin[encoder_n]))
        {
            return_value = -result;
        }
		else
		{
			return_value = result;
		}
    }

    return return_value;
}

//-------------------------------------------------------------------------------------------------------------------
//      ʱļ
// ˵     timer_ch      ʱö
// ز     void
// עϢ
// ʹʾ    encoder_clear_count(TIM1_ENCOEDER)  //ʱ1ɼı
//-------------------------------------------------------------------------------------------------------------------
void encoder_clear_count(encoder_index_enum encoder_n)
{
    switch(encoder_n)
    {
        case TIM1_ENCOEDER:  TIM1->CNT  = 0;  break;
        case TIM2_ENCOEDER:  TIM2->CNT  = 0;  break;
        case TIM3_ENCOEDER:  TIM3->CNT  = 0;  break;
        case TIM4_ENCOEDER:  TIM4->CNT  = 0;  break;
        case TIM5_ENCOEDER:  TIM5->CNT  = 0;  break;
        case TIM8_ENCOEDER:  TIM8->CNT  = 0;  break;
        case TIM9_ENCOEDER:  TIM9->CNT  = 0;  break;
        case TIM10_ENCOEDER: TIM10->CNT = 0;  break;
        default:  break;
    }
}

//-------------------------------------------------------------------------------------------------------------------
//      ʼ
// ˵     timer_ch      ʱö
// ˵     phaseA      ͨAԼ
// ˵     phaseB      ͨBԼ
// ز     void
// עϢ    Ƽʹ
// ʹʾ    encoder_init_quad(TIM1_ENCOEDER, TIM1_CH1_ENCOEDER_E9, TIM1_CH2_ENCOEDER_E11)
//          // ʹöʱ1 룬 ͨ1źE9ͨ2źE11
//-------------------------------------------------------------------------------------------------------------------
void encoder_quad_init(encoder_index_enum encoder_n, encoder_channel_enum ch1_pin, encoder_channel_enum ch2_pin)
{
    uint32 register_temp = 0;
    TIM_TypeDef *tim_index;

    // ˶Ϣ ʾλ
    // ȥ鿴ʲôط Ĵ
    // ǼǷظʹöʱ
    // ʼ TIM1_PWM Ȼֳʼ TIM1_ENCODER ÷ǲ
    zf_assert(timer_funciton_check((timer_index_enum)encoder_n, TIMER_FUNCTION_ENCODER));
    zf_assert((ch1_pin >> 12) == (encoder_n));                                  // ch1_pin  ch2_pin  encoder_n ƥ
    zf_assert((ch2_pin >> 12) == (encoder_n));                                  // ch1_pin  ch2_pin  encoder_n ƥ

    timer_clock_enable(encoder_n);                                              // ʱʱʹ

    gpio_init((gpio_pin_enum)(ch1_pin & 0xFF), GPI, 0, GPI_PULL_UP);            // ʼ
    gpio_init((gpio_pin_enum)(ch2_pin & 0xFF), GPI, 0, GPI_PULL_UP);            // ʼ

    //encoder_dir_pin[encoder_n] = (ch1_pin &0xFF);                               // źŴ

    switch(encoder_n)
    {
        case TIM1_ENCOEDER:  tim_index = ((TIM_TypeDef *)TIM1_BASE);   break;
        case TIM2_ENCOEDER:  tim_index = ((TIM_TypeDef *)TIM2_BASE);   break;
        case TIM3_ENCOEDER:  tim_index = ((TIM_TypeDef *)TIM3_BASE);   break;
        case TIM4_ENCOEDER:  tim_index = ((TIM_TypeDef *)TIM4_BASE);   break;
        case TIM5_ENCOEDER:  tim_index = ((TIM_TypeDef *)TIM5_BASE);   break;
        case TIM8_ENCOEDER:  tim_index = ((TIM_TypeDef *)TIM8_BASE);   break;
        case TIM9_ENCOEDER:  tim_index = ((TIM_TypeDef *)TIM9_BASE);   break;
        case TIM10_ENCOEDER: tim_index = ((TIM_TypeDef *)TIM10_BASE);  break;
        default: register_temp = 1;
    }

    // ù
    if((ch1_pin >> 8) == 0x03)      GPIO_PinRemapConfig(GPIO_FullRemap_TIM1,        ENABLE);
    else if((ch1_pin >> 8) == 0x11) GPIO_PinRemapConfig(GPIO_PartialRemap1_TIM2,    ENABLE);
    else if((ch1_pin >> 8) == 0x22) GPIO_PinRemapConfig(GPIO_PartialRemap_TIM3,     ENABLE);
    else if((ch1_pin >> 8) == 0x23) GPIO_PinRemapConfig(GPIO_FullRemap_TIM3,        ENABLE);
    else if((ch1_pin >> 8) == 0x31) GPIO_PinRemapConfig(GPIO_Remap_TIM4,            ENABLE);
    else if((ch1_pin >> 8) == 0x71) GPIO_PinRemapConfig(GPIO_Remap_TIM8,            ENABLE);
    else if((ch1_pin >> 8) == 0x83) GPIO_PinRemapConfig(GPIO_FullRemap_TIM9,        ENABLE);
    else if((ch1_pin >> 8) == 0x91) GPIO_PinRemapConfig(GPIO_PartialRemap_TIM10,    ENABLE);
    else if((ch1_pin >> 8) == 0x93) GPIO_PinRemapConfig(GPIO_FullRemap_TIM10,       ENABLE);

    if(!register_temp)
    {
        RCC_APB2PeriphClockCmd(RCC_APB2Periph_AFIO, ENABLE);                // ʹAFIOùģʱ
        TIM_TimeBaseInitTypeDef TIM_TimeBaseStructure = {0};
        TIM_TimeBaseStructInit(&TIM_TimeBaseStructure);
        TIM_TimeBaseStructure.TIM_Prescaler = 0;                            // ԤƵ
        TIM_TimeBaseStructure.TIM_Period = 0xFFFF;                          // 趨Զװֵ
        TIM_TimeBaseStructure.TIM_ClockDivision = TIM_CKD_DIV1;             // ѡʱӷƵƵ
        TIM_TimeBaseStructure.TIM_CounterMode = TIM_CounterMode_Up;         // TIMϼ
        TIM_TimeBaseStructure.TIM_RepetitionCounter = 0;                    // ظ
        TIM_TimeBaseInit(tim_index, &TIM_TimeBaseStructure);                // ʼṹ
        TIM_ITRxExternalClockConfig(tim_index, TIM_TS_TI2FP2);              // ⲿ򲻻
        TIM_Cmd(tim_index, ENABLE);                                         // ʱʹ

        TIM_EncoderInterfaceConfig(
                tim_index,
                TIM_EncoderMode_TI2 ,
                TIM_ICPolarity_Rising,
                TIM_ICPolarity_Rising);                                     // ʹñģʽ, T2 ,T1жϷ, ؼ

        TIM_Cmd(tim_index, ENABLE);                                         // ʱʹ

    }

}


//-------------------------------------------------------------------------------------------------------------------
//      ʼ
// ˵     timer_ch        ʱö
// ˵     phaseA          ͨAԼ
// ˵     phaseB          ͨBԼ
// ز     void
//          Ƽʹ
// ʹʾ      encoder_init_dir(TIM1_ENCOEDER, TIM1_CH1_ENCOEDER_E9, TIM1_CH2_ENCOEDER_E11)
//                              // ʹöʱ1 ı룬 ͨ1źE9ͨ2źE11
//-------------------------------------------------------------------------------------------------------------------
void encoder_dir_init(encoder_index_enum encoder_n, encoder_channel_enum ch1_pin, encoder_channel_enum ch2_pin)
{
    uint32 register_temp = 0;
    TIM_TypeDef *tim_index;

    // ˶Ϣ ʾλ
    // ȥ鿴ʲôط Ĵ
    // ǼǷظʹöʱ
    // ʼ TIM1_PWM Ȼֳʼ TIM1_ENCODER ÷ǲ
    zf_assert(timer_funciton_check((timer_index_enum)encoder_n, TIMER_FUNCTION_ENCODER));
    zf_assert((ch1_pin & (encoder_n << 12)) == (encoder_n << 12));              // ch1_pin  ch2_pin  encoder_n ƥ
    zf_assert((ch2_pin & (encoder_n << 12)) == (encoder_n << 12));              // ch1_pin  ch2_pin  encoder_n ƥ

    timer_clock_enable(encoder_n);                                              // ʱʱʹ

    gpio_init((gpio_pin_enum)(ch1_pin & 0xFF), GPI, 0, GPI_PULL_UP);            // ʼ
    gpio_init((gpio_pin_enum)(ch2_pin & 0xFF), GPI, 0, GPI_PULL_UP);            // ʼ

    encoder_dir_pin[encoder_n] = (ch1_pin &0xFF);                               // źŴ

    switch(encoder_n)
    {
        case TIM1_ENCOEDER:  tim_index = ((TIM_TypeDef *)TIM1_BASE);   break;
        case TIM2_ENCOEDER:  tim_index = ((TIM_TypeDef *)TIM2_BASE);   break;
        case TIM3_ENCOEDER:  tim_index = ((TIM_TypeDef *)TIM3_BASE);   break;
        case TIM4_ENCOEDER:  tim_index = ((TIM_TypeDef *)TIM4_BASE);   break;
        case TIM5_ENCOEDER:  tim_index = ((TIM_TypeDef *)TIM5_BASE);   break;
        case TIM8_ENCOEDER:  tim_index = ((TIM_TypeDef *)TIM8_BASE);   break;
        case TIM9_ENCOEDER:  tim_index = ((TIM_TypeDef *)TIM9_BASE);   break;
        case TIM10_ENCOEDER: tim_index = ((TIM_TypeDef *)TIM10_BASE);  break;
        default: register_temp = 1;
    }

    RCC_APB2PeriphClockCmd(RCC_APB2Periph_AFIO, ENABLE);                // ʹAFIOùģʱ

    // ù
    if((ch1_pin >> 8) == 0x03)      GPIO_PinRemapConfig(GPIO_FullRemap_TIM1,        ENABLE);
    else if((ch1_pin >> 8) == 0x11) GPIO_PinRemapConfig(GPIO_PartialRemap1_TIM2,    ENABLE);
    else if((ch1_pin >> 8) == 0x22) GPIO_PinRemapConfig(GPIO_PartialRemap_TIM3,     ENABLE);
    else if((ch1_pin >> 8) == 0x23) GPIO_PinRemapConfig(GPIO_FullRemap_TIM3,        ENABLE);
    else if((ch1_pin >> 8) == 0x31) GPIO_PinRemapConfig(GPIO_Remap_TIM4,            ENABLE);
    else if((ch1_pin >> 8) == 0x71) GPIO_PinRemapConfig(GPIO_Remap_TIM8,            ENABLE);
    else if((ch1_pin >> 8) == 0x83) GPIO_PinRemapConfig(GPIO_FullRemap_TIM9,        ENABLE);
    else if((ch1_pin >> 8) == 0x91) GPIO_PinRemapConfig(GPIO_PartialRemap_TIM10,    ENABLE);
    else if((ch1_pin >> 8) == 0x93) GPIO_PinRemapConfig(GPIO_FullRemap_TIM10,       ENABLE);

    if(!register_temp)
    {
        TIM_TimeBaseInitTypeDef TIM_TimeBaseStructure = {0};
        TIM_TimeBaseStructInit(&TIM_TimeBaseStructure);
        TIM_TimeBaseStructure.TIM_Prescaler = 0;                            // ԤƵ
        TIM_TimeBaseStructure.TIM_Period = 0xFFFF;                          // 趨Զװֵ
        TIM_TimeBaseStructure.TIM_ClockDivision = TIM_CKD_DIV1;             // ѡʱӷƵƵ
        TIM_TimeBaseStructure.TIM_CounterMode = TIM_CounterMode_Up;         // TIMϼ
        TIM_TimeBaseStructure.TIM_RepetitionCounter = 0;                    // ظ
        TIM_TimeBaseInit(tim_index, &TIM_TimeBaseStructure);                // ʼṹ
        TIM_ITRxExternalClockConfig(tim_index, TIM_TS_TI2FP2);              // ⲿ򲻻
		TIM_ETRConfig(tim_index, TIM_ExtTRGPSC_OFF, TIM_ExtTRGPolarity_NonInverted, 15);	// ƵFsampling=Fdts/32N=8
		TIM_Cmd(tim_index, ENABLE);                                         // ʱʹ
    }
}

