/*********************************************************************************************************************
* CH32V307VCT6 Opensourec Library CH32V307VCT6 Դ⣩һڹٷ SDK ӿڵĵԴ
* Copyright (c) 2022 SEEKFREE ɿƼ
*
* ļCH32V307VCT6 Դһ
*
* CH32V307VCT6 Դ 
* Ըᷢ GPLGNU General Public License GNUͨù֤
*  GPL ĵ3棨 GPL3.0ѡģκκİ汾·/޸
*
* Դķϣܷãδκεı֤
* ûԻʺض;ı֤
* ϸμ GPL
*
* ӦյԴͬʱյһ GPL ĸ
* ûУ<https://www.gnu.org/licenses/>
*
* ע
* Դʹ GPL3.0 Դ֤Э Ϊİ汾
* Ӣİ libraries/doc ļµ GPL3_permission_statement.txt ļ
* ֤ libraries ļ ļµ LICENSE ļ
* ӭλʹò ޸ʱ뱣ɿƼİȨ
*
* ļ          zf_driver_exti
* ˾          ɶɿƼ޹˾
* 汾Ϣ          鿴 libraries/doc ļ version ļ 汾˵
*           MounRiver Studio V1.8.1
* ƽ̨          CH32V307VCT6
*           https://seekfree.taobao.com/
*
* ޸ļ¼
*                                                                    ע
* 2022-09-15        W            first version
********************************************************************************************************************/

#include "zf_common_interrupt.h"

#include "zf_driver_exti.h"
#include "zf_driver_gpio.h"

//-------------------------------------------------------------------------------------------------------------------
//      EXTI жʹ
// ˵     pin              ѡ EXTI  (ѡΧ zf_driver_gpio.h  gpio_pin_enum öֵȷ)
// ز     void
// ʹʾ     exti_enable(A0);
//-------------------------------------------------------------------------------------------------------------------
void exti_enable (gpio_pin_enum pin)
{
    EXTI->INTENR |= (0x00000001 << (pin&0x1F));
}

//-------------------------------------------------------------------------------------------------------------------
//      EXTI жʧ
// ˵     pin             ѡ EXTI  (ѡΧ zf_driver_gpio.h  gpio_pin_enum öֵȷ)
// ز     void
// ʹʾ     exti_disable(A0);
//-------------------------------------------------------------------------------------------------------------------
void exti_disable (gpio_pin_enum pin)
{
    EXTI->INTENR &= ~(0x00000001 << (pin&0x1F));
}


//-------------------------------------------------------------------------------------------------------------------
//      EXTI жϳʼ <ͬһ±ŲͬʱʼΪⲿж  A0  B0 ͬʱʼΪⲿж>
// ˵     pin             ѡ EXTI  (ѡΧ zf_driver_gpio.h  gpio_pin_enum öֵȷ)
// ˵     trigger         ѡ񴥷źŷʽ [EXTI_TRIGGER_RISING/EXTI_TRIGGER_FALLING/EXTI_TRIGGER_BOTH]
// ز     void
// ʹʾ     exti_init(A0, EXTI_TRIGGER_RISING);
//-------------------------------------------------------------------------------------------------------------------
void exti_init (gpio_pin_enum pin, exti_trigger_enum trigger)
{
    RCC_APB2PeriphClockCmd(RCC_APB2Periph_AFIO,ENABLE);                         // ʱʹ
    gpio_init(pin, GPI, GPIO_HIGH, GPI_PULL_UP);                                // ʼѡе
    GPIO_EXTILineConfig(pin >> 5, pin & 0x1F);                                  // ѡһGPIOж

    EXTI_InitTypeDef EXTI_InitStructure = {0};
    EXTI_InitStructure.EXTI_Line = 1 << (pin & 0x1F);                           // ź
    EXTI_InitStructure.EXTI_Mode = EXTI_Mode_Interrupt;                         // ģʽ
    EXTI_InitStructure.EXTI_Trigger = trigger;                                  // ʽ
    EXTI_InitStructure.EXTI_LineCmd = ENABLE;                                   // ʹܻʧ
    EXTI_Init(&EXTI_InitStructure);

    if((pin&0x1F) < 1)
       interrupt_enable(EXTI0_IRQn);                                             // ʹ Line0 жӦ
    else if((pin&0x1F) < 2)
       interrupt_enable(EXTI1_IRQn);                                             // ʹ Line1 жӦ
    else if((pin&0x1F) < 3)
       interrupt_enable(EXTI2_IRQn);                                             // ʹ Line2 жӦ
    else if((pin&0x1F) < 4)
       interrupt_enable(EXTI3_IRQn);                                             // ʹ Line3 жӦ
    else if((pin&0x1F) < 5)
       interrupt_enable(EXTI4_IRQn);                                             // ʹ Line4 жӦ
    else if((pin&0x1F) < 10)
       interrupt_enable(EXTI9_5_IRQn);                                           // ʹ Line5-9 жӦ
    else
       interrupt_enable(EXTI15_10_IRQn);                                         // ʹ Line10-15 жӦ
}

