/*********************************************************************************************************************
* CH32V307VCT6 Opensourec Library CH32V307VCT6 Դ⣩һڹٷ SDK ӿڵĵԴ
* Copyright (c) 2022 SEEKFREE ɿƼ
*
* ļCH32V307VCT6 Դһ
*
* CH32V307VCT6 Դ 
* Ըᷢ GPLGNU General Public License GNUͨù֤
*  GPL ĵ3棨 GPL3.0ѡģκκİ汾·/޸
*
* Դķϣܷãδκεı֤
* ûԻʺض;ı֤
* ϸμ GPL
*
* ӦյԴͬʱյһ GPL ĸ
* ûУ<https://www.gnu.org/licenses/>
*
* ע
* Դʹ GPL3.0 Դ֤Э Ϊİ汾
* Ӣİ libraries/doc ļµ GPL3_permission_statement.txt ļ
* ֤ libraries ļ ļµ LICENSE ļ
* ӭλʹò ޸ʱ뱣ɿƼİȨ
*
* ļ          zf_driver_flash
* ˾          ɶɿƼ޹˾
* 汾Ϣ          鿴 libraries/doc ļ version ļ 汾˵
*           MounRiver Studio V1.8.1
* ƽ̨          CH32V307VCT6
*           https://seekfree.taobao.com/
*
* ޸ļ¼
*                                                                    ע
* 2022-09-15        W            first version
********************************************************************************************************************/



#include "zf_common_debug.h"
#include "zf_common_interrupt.h"
#include "zf_common_clock.h"

#include "zf_driver_flash.h"

flash_data_union flash_union_buffer[FLASH_DATA_BUFFER_SIZE];               // FLASH ݻ

//-------------------------------------------------------------------------------------------------------------------
//      У FLASH Ƿ
// ˵     sector_num      Ҫд Χ <0 - 63>
// ˵     page_num        ǰҳı   Χ <0 - 3>
// ز     uint8           1- 0-û ҪݵдµӦöв
// ʹʾ     flash_check(63, 3);
// עϢ
//-------------------------------------------------------------------------------------------------------------------
uint8 flash_check (uint32 sector_num, uint32 page_num)
{
    zf_assert(sector_num <= FLASH_MAX_SECTION_INDEX);                                                   // Χ 0-63
    zf_assert(page_num <= FLASH_MAX_PAGE_INDEX);                                                        // Χ 0-3

    uint8  return_state = 0;
    uint16 temp_loop;
    uint32 flash_addr = ((FLASH_BASE_ADDR+FLASH_SECTION_SIZE*sector_num+FLASH_PAGE_SIZE*page_num));     // ȡǰ Flash ַ

    uint32 primask = interrupt_global_disable();

    //clock_reset();                                  // λʱ
    //clock_set_freq(SYSTEM_CLOCK_120M);          // ϵͳƵΪ120Mhz

    for(temp_loop = 0; temp_loop < FLASH_PAGE_SIZE; temp_loop+=4)                                       // ѭȡ Flash ֵ
    {
        if( (*(__IO u32*) (flash_addr+temp_loop)) != 0xE339E339 )                                       // õƬ 0xE339E339 Ǿֵ
        {
            return_state = 1;
            break;
        }
    }

    //clock_reset();                                  // λʱ
    //clock_set_freq(system_clock);       // ûԭϵͳƵ
    interrupt_global_enable(primask);

    return return_state;
}

//-------------------------------------------------------------------------------------------------------------------
//      һ(4KB)
// ˵     sector_num      Ҫд Χ <0 - 63>
// ˵     page_num        ǰҳı   Χ <0 - 3>
// ز     uint8           1-ʾʧ 0-ʾɹ
// ʹʾ     flash_erase_page(63, 3);
// עϢ
//          ׼ֻǲһݣ4KBֽڳ
//-------------------------------------------------------------------------------------------------------------------
uint8 flash_erase_sector (uint32 sector_num, uint32 page_num)
{
    zf_assert(sector_num <= FLASH_MAX_SECTION_INDEX);                                                   // Χ 0-63
    zf_assert(page_num <= FLASH_MAX_PAGE_INDEX);                                                        // Χ 0-3

    uint8 return_state = 0;

    static volatile FLASH_Status gFlashStatus = FLASH_COMPLETE;
    uint32 flash_addr = ((FLASH_BASE_ADDR+FLASH_SECTION_SIZE*sector_num+FLASH_PAGE_SIZE*page_num));     // ȡǰ Flash ַ

    uint32 primask = interrupt_global_disable();
    //clock_reset();                      // λʱ
    //clock_set_freq(SYSTEM_CLOCK_120M);          // ϵͳƵΪ120Mhz

    FLASH_Unlock();                                                                                     //  Flash
    FLASH_ClearFlag(FLASH_FLAG_EOP | FLASH_FLAG_PGERR | FLASH_FLAG_WRPRTERR);                           // ־
    gFlashStatus = FLASH_ErasePage(flash_addr);                                                         // 
    FLASH_ClearFlag(FLASH_FLAG_EOP );                                                                   // ־
    FLASH_Lock();                                                                                       //  Flash
    if(gFlashStatus != FLASH_COMPLETE)          // жϲǷɹ
    {
        return_state = 1;
    }

    //clock_reset();                      // λʱ
    //clock_set_freq(system_clock);       // ûԭϵͳƵ
    interrupt_global_enable(primask);
    return return_state;
}

//-------------------------------------------------------------------------------------------------------------------
//      ȡһҳ
// ˵     sector_num      Ҫд Χ <0 - 63>
// ˵     page_num        ǰҳı   Χ <0 - 3>
// ˵     buf             Ҫȡݵַ   ͱΪuint32
// ˵     len             Ҫдݳ   Χ 1-256
// ز     void
// ʹʾ     flash_read_page(63, 3, data_buffer, 256);
// עϢ
//-------------------------------------------------------------------------------------------------------------------
void flash_read_page (uint32 sector_num, uint32 page_num, uint32 *buf, uint16 len)
{
    zf_assert(sector_num <= FLASH_MAX_SECTION_INDEX);                                                   // Χ 0-63
    zf_assert(page_num <= FLASH_MAX_PAGE_INDEX);                                                        // Χ 0-3
    zf_assert(len <= FLASH_DATA_BUFFER_SIZE);

    uint16 temp_loop = 0;
    uint32 flash_addr = 0;
    flash_addr = ((FLASH_BASE_ADDR+FLASH_SECTION_SIZE*sector_num+FLASH_PAGE_SIZE*page_num));            // ȡǰ Flash ַ

    uint32 primask = interrupt_global_disable();
    //clock_reset();                      // λʱ
    //clock_set_freq(SYSTEM_CLOCK_120M);          // ϵͳƵΪ120Mhz


    for(temp_loop = 0; temp_loop < len; temp_loop++)                                                    // ָȶȡ
    {
        *buf++ = *(__IO uint32*)(flash_addr+temp_loop*4);                                               // ѭȡ Flash ֵ
    }
                                                                                       //  Flash
    //clock_reset();                      // λʱ
    //clock_set_freq(system_clock);       // ûԭϵͳƵ
    interrupt_global_enable(primask);
}

//-------------------------------------------------------------------------------------------------------------------
//      һҳ
// ˵     sector_num      Ҫд Χ <0 - 63>
// ˵     page_num        ǰҳı   Χ <0 - 3>
// ˵     buf             Ҫдݵַ   ͱΪ uint32
// ˵     len             Ҫдݳ   Χ 1-256
// ز     uint8           1-ʾʧ 0-ʾɹ
// ʹʾ     flash_write_page(63, 3, data_buffer, 256);
// עϢ
//-------------------------------------------------------------------------------------------------------------------
uint8 flash_write_page (uint32 sector_num, uint32 page_num, const uint32 *buf, uint16 len)
{
    zf_assert(sector_num <= FLASH_MAX_SECTION_INDEX);                                                   // Χ 0-63
    zf_assert(page_num <= FLASH_MAX_PAGE_INDEX);                                                        // Χ 0-3
    zf_assert(len <= FLASH_DATA_BUFFER_SIZE);
    uint8 return_state = 0;
    static volatile FLASH_Status gFlashStatus = FLASH_COMPLETE;
    uint32 flash_addr = 0;
    flash_addr = ((FLASH_BASE_ADDR+FLASH_SECTION_SIZE*sector_num+FLASH_PAGE_SIZE*page_num));            // ȡǰ Flash ַ

    if(flash_check(sector_num, page_num))                                                               // жǷ ı ֹûд
    {
        flash_erase_sector(sector_num, page_num);                                                       // һ
    }

    uint32 primask = interrupt_global_disable();
    //clock_reset();                      // λʱ
    //clock_set_freq(SYSTEM_CLOCK_120M);          // ϵͳƵΪ120Mhz
    FLASH_Unlock();                                                                                     //  Flash
    while(len--)                                                                                        // ݳ
    {
        gFlashStatus = FLASH_ProgramWord(flash_addr, *buf++);                                           //  32bit д
        if(gFlashStatus != FLASH_COMPLETE)                                                              // ȷϲǷɹ
        {
            return_state = 1;
            break;
        }
        flash_addr += 4;                                                                                // ַ
    }
    FLASH_Lock();                                                                                       //  Flash
    //clock_reset();                      // λʱ
    //clock_set_freq(system_clock);       // ûԭϵͳƵ
    interrupt_global_enable(primask);

    return return_state;
}


//-------------------------------------------------------------------------------------------------------------------
//      ָ FLASH ָҳȡݵ
// ˵     sector_num      Ҫд Χ <0 - 63>
// ˵     page_num        ǰҳı   Χ <0 - 3>
// ز     void
// ʹʾ     flash_read_page_to_buffer(63, 3);
// עϢ
//-------------------------------------------------------------------------------------------------------------------
void flash_read_page_to_buffer (uint32 sector_num, uint32 page_num)
{
    zf_assert(sector_num <= FLASH_MAX_SECTION_INDEX);                                                   // Χ 0-63
    zf_assert(page_num <= FLASH_MAX_PAGE_INDEX);                                                        // Χ 0-3
    uint16 temp_loop;
    uint32 flash_addr = ((FLASH_BASE_ADDR + FLASH_SECTION_SIZE*sector_num + FLASH_PAGE_SIZE*page_num)); // ȡǰ Flash ַ



    for(temp_loop = 0; temp_loop < FLASH_DATA_BUFFER_SIZE; temp_loop++)                                 // ָȶȡ
    {
        flash_union_buffer[temp_loop].uint32_type = *(__IO uint32*)(flash_addr+temp_loop*4);            // ѭȡ Flash ֵ
    }


}

//-------------------------------------------------------------------------------------------------------------------
//      ָ FLASH ָҳд뻺
// ˵     sector_num      Ҫд Χ <0 - 63>
// ˵     page_num        ǰҳı   Χ <0 - 3>
// ز     uint8           1-ʾʧ 0-ʾɹ
// ʹʾ     flash_write_page_from_buffer(63, 3);
// עϢ
//-------------------------------------------------------------------------------------------------------------------
uint8 flash_write_page_from_buffer (uint32 sector_num, uint32 page_num)
{
    zf_assert(sector_num <= FLASH_MAX_SECTION_INDEX);                                                   // Χ 0-63
    zf_assert(page_num <= FLASH_MAX_PAGE_INDEX);                                                        // Χ 0-3
    uint8 return_state = 0;

    static volatile FLASH_Status gFlashStatus = FLASH_COMPLETE;
    uint32 flash_addr = 0;
    uint16 len = 0;
    flash_addr = ((FLASH_BASE_ADDR+FLASH_SECTION_SIZE*sector_num+FLASH_PAGE_SIZE*page_num));            // ȡǰ Flash ַ

    if(flash_check(sector_num, page_num))                                                               // жǷ ı ֹûд
        flash_erase_sector(sector_num, page_num);                                                       // һҳ

    uint32 primask = interrupt_global_disable();
    //clock_reset();                      // λʱ
    //clock_set_freq(SYSTEM_CLOCK_120M);          // ϵͳƵΪ120Mhz

    FLASH_Unlock();                                                                                     //  Flash
    while(len < FLASH_DATA_BUFFER_SIZE)                                                                 // ݳ
    {
        gFlashStatus = FLASH_ProgramWord(flash_addr, flash_union_buffer[len].uint32_type);              //  32bit д
        if(gFlashStatus != FLASH_COMPLETE)                                                              // ȷϲǷɹ
        {
            return_state = 1;
            break;
        }

        len++;                                                                                          // 
        flash_addr += 4;                                                                                // ַ
    }
    FLASH_Lock();                                                                                       //  Flash

    //clock_reset();                      // λʱ
    //clock_set_freq(system_clock);       // ûԭϵͳƵ
    interrupt_global_enable(primask);

    return return_state;
}


//-------------------------------------------------------------------------------------------------------------------
//      ݻ
// ˵     void
// ز     void
// ʹʾ     flash_buffer_clear();
// עϢ
//-------------------------------------------------------------------------------------------------------------------
void flash_buffer_clear (void)
{
    memset(flash_union_buffer, 0xFF, FLASH_PAGE_SIZE);
}

