/*********************************************************************************************************************
* CH32V307VCT6 Opensourec Library CH32V307VCT6 Դ⣩һڹٷ SDK ӿڵĵԴ
* Copyright (c) 2022 SEEKFREE ɿƼ
*
* ļCH32V307VCT6 Դһ
*
* CH32V307VCT6 Դ 
* Ըᷢ GPLGNU General Public License GNUͨù֤
*  GPL ĵ3棨 GPL3.0ѡģκκİ汾·/޸
*
* Դķϣܷãδκεı֤
* ûԻʺض;ı֤
* ϸμ GPL
*
* ӦյԴͬʱյһ GPL ĸ
* ûУ<https://www.gnu.org/licenses/>
*
* ע
* Դʹ GPL3.0 Դ֤Э Ϊİ汾
* Ӣİ libraries/doc ļµ GPL3_permission_statement.txt ļ
* ֤ libraries ļ ļµ LICENSE ļ
* ӭλʹò ޸ʱ뱣ɿƼİȨ
*
* ļ          zf_driver_pit
* ˾          ɶɿƼ޹˾
* 汾Ϣ          鿴 libraries/doc ļ version ļ 汾˵
*           MounRiver Studio V1.8.1
* ƽ̨          CH32V307VCT6
*           https://seekfree.taobao.com/
*
* ޸ļ¼
*                                                                    ע
* 2022-09-15        W            first version
********************************************************************************************************************/


#include "ch32v30x_rcc.h"
#include "zf_common_clock.h"
#include "zf_common_debug.h"
#include "zf_common_interrupt.h"
#include "zf_driver_timer.h"

#include "zf_driver_pit.h"

//-------------------------------------------------------------------------------------------------------------------
//       PIT жʹ
// ˵     pit_n           PIT ģ
// ز     void
// ʹʾ     pit_enable(TIM1_PIT);
//-------------------------------------------------------------------------------------------------------------------
void pit_enable (pit_index_enum pit_n)
{
    const uint32 irq_index[] =
    {
        TIM1_UP_IRQn,
        TIM2_IRQn,
        TIM3_IRQn,
        TIM4_IRQn,
        TIM5_IRQn,
        TIM6_IRQn,
        TIM7_IRQn,
        TIM8_UP_IRQn,
        TIM9_UP_IRQn,
        TIM10_UP_IRQn
    };
    interrupt_enable(irq_index[pit_n]);                                // ʹж
}

//-------------------------------------------------------------------------------------------------------------------
//       PIT жϽֹ
// ˵     pit_n           PIT ģ
// ز     void
// ʹʾ     pit_disable(TIM1_PIT);
//-------------------------------------------------------------------------------------------------------------------
void pit_disable (pit_index_enum pit_n)
{
    const uint32 irq_index[] =
    {
        TIM1_UP_IRQn,
        TIM2_IRQn,
        TIM3_IRQn,
        TIM4_IRQn,
        TIM5_IRQn,
        TIM6_IRQn,
        TIM7_IRQn,
        TIM8_UP_IRQn,
        TIM9_UP_IRQn,
        TIM10_UP_IRQn
    };

    interrupt_disable(irq_index[pit_n]);                                // ʧж

}

//-------------------------------------------------------------------------------------------------------------------
//      ʱж
// ˵     timer_ch      ʱͨ
// ˵     us          ʱ(1-65535)
// ز     void
// עϢ           pit_init(TIMER_1, 5); ʹöʱ1Ϊ5msһεж
//-------------------------------------------------------------------------------------------------------------------
void pit_init (pit_index_enum pit_n, uint32 period)
{

    // ˶Ϣ ʾλ
    // ȥ鿴ʲôط Ĵ
    // ǼǷظʹöʱ
    // ʼ TIM1_PWM Ȼֳʼ TIM1_PIT ÷ǲ
    zf_assert(timer_funciton_check((timer_index_enum)pit_n, TIMER_FUNCTION_TIMER));
    // һб Ҿ͵Ϊʲôд 0
    zf_assert(period!=0);

    uint16 freq_div = (period >> 15);                                           // ԤƵ
    uint16 period_temp = (period / (freq_div+1));                               // Զװֵ

    timer_clock_enable(pit_n);                                                  // ʹʱ


    TIM_TypeDef *tim_index = TIM1;
    switch(pit_n)
    {
        case TIM_1:  tim_index = ((TIM_TypeDef *)TIM1_BASE);    break;
        case TIM_2:  tim_index = ((TIM_TypeDef *)TIM2_BASE);    break;
        case TIM_3:  tim_index = ((TIM_TypeDef *)TIM3_BASE);    break;
        case TIM_4:  tim_index = ((TIM_TypeDef *)TIM4_BASE);    break;
        case TIM_5:  tim_index = ((TIM_TypeDef *)TIM5_BASE);    break;
        case TIM_6:  tim_index = ((TIM_TypeDef *)TIM6_BASE);    break;
        case TIM_7:  tim_index = ((TIM_TypeDef *)TIM7_BASE);    break;
        case TIM_8:  tim_index = ((TIM_TypeDef *)TIM8_BASE);    break;
        case TIM_9:  tim_index = ((TIM_TypeDef *)TIM9_BASE);    break;
        case TIM_10: tim_index = ((TIM_TypeDef *)TIM10_BASE);   break;
    }


    TIM_TimeBaseInitTypeDef  TIM_TimeBaseStructure = {0};
    TIM_TimeBaseStructure.TIM_Period = period_temp;
    TIM_TimeBaseStructure.TIM_Prescaler = freq_div;                             // Ƶֵ
    TIM_TimeBaseStructure.TIM_ClockDivision = TIM_CKD_DIV1;                     // ʱӷָ:TDTS = Tck_tim
    TIM_TimeBaseStructure.TIM_CounterMode = TIM_CounterMode_Up;                 // TIMϼģʽ
    TIM_TimeBaseStructure.TIM_RepetitionCounter = 0;                            // ظΪ0
    TIM_TimeBaseInit(tim_index, &TIM_TimeBaseStructure);                        // ָĲʼTIMxʱλ
    TIM_ITConfig(tim_index,TIM_IT_Update,ENABLE );                              // ʹָTIMж,ж
    TIM_ClearITPendingBit(tim_index, TIM_IT_Update);

    const uint32  irq_index[10] =
    {
        TIM1_UP_IRQn,
        TIM2_IRQn,
        TIM3_IRQn,
        TIM4_IRQn,
        TIM5_IRQn,
        TIM6_IRQn,
        TIM7_IRQn,
        TIM8_UP_IRQn,
        TIM9_UP_IRQn,
        TIM10_UP_IRQn
    };

    interrupt_set_priority((IRQn_Type)irq_index[(uint8)pit_n], 0x03);           // жȼ
    interrupt_enable((IRQn_Type)irq_index[pit_n]);                              // ʹж

    TIM_Cmd(tim_index, ENABLE);                                                 // ʹܶʱ
}
