/*********************************************************************************************************************
* CH32V307VCT6 Opensourec Library CH32V307VCT6 Դ⣩һڹٷ SDK ӿڵĵԴ
* Copyright (c) 2022 SEEKFREE ɿƼ
*
* ļCH32V307VCT6 Դһ
*
* CH32V307VCT6 Դ 
* Ըᷢ GPLGNU General Public License GNUͨù֤
*  GPL ĵ3棨 GPL3.0ѡģκκİ汾·/޸
*
* Դķϣܷãδκεı֤
* ûԻʺض;ı֤
* ϸμ GPL
*
* ӦյԴͬʱյһ GPL ĸ
* ûУ<https://www.gnu.org/licenses/>
*
* ע
* Դʹ GPL3.0 Դ֤Э Ϊİ汾
* Ӣİ libraries/doc ļµ GPL3_permission_statement.txt ļ
* ֤ libraries ļ ļµ LICENSE ļ
* ӭλʹò ޸ʱ뱣ɿƼİȨ
*
* ļ          zf_driver_usb_cdc
* ˾          ɶɿƼ޹˾
* 汾Ϣ          鿴 libraries/doc ļ version ļ 汾˵
*           MounRiver Studio V1.8.1
* ƽ̨          CH32V307VCT6
*           https://seekfree.taobao.com/
*
* ޸ļ¼
*                                                                    ע
* 2022-09-15        W            first version
********************************************************************************************************************/
#include "ch32v30x.h"
#include "zf_driver_delay.h"
#include "zf_driver_usb_cdc.h"



//-------------------------------------------------------------------------------------------------------------------
//      USB_CDCһ 
// ˵     *p          Ҫ͵ָ
// ˵     length      Ͷٸ( length ҪС64)
// ز     void
// עϢ
//-------------------------------------------------------------------------------------------------------------------
void cdc_send_pack(const uint8 *p, uint32 length)
{
    uint32 i = 0;

    for(i=0; i<length; i++)
    {
       pEP2_IN_DataBuf[i] = p[i];
    }
    DevEP2_IN_Deal(length);

    //ȴ
    while(!(USBOTG_FS->UEP2_TX_CTRL&USBHD_UEP_T_RES1));

    // bUEP_T_RES1 & bUEP_T_RES0: handshake response type for USB endpoint X transmittal (IN)
    // 00: DATA0 or DATA1 then expecting ACK (ready)
    // 01: DATA0 or DATA1 then expecting no response, time out from host, for non-zero endpoint isochronous transactions
    // 10: NAK (busy)
    // 11: TALL (error)
}


//-------------------------------------------------------------------------------------------------------------------
//      ͼݵλ
// ˵     *image          ͼ
// ˵     length          Ͷٸ
// ز     void
// עϢ
//-------------------------------------------------------------------------------------------------------------------
void camera_send_image_usb_cdc(const uint8 *image, uint32 length)
{
    uint8 send_buffer[4] = {0x00,0xff,0x01,0x01};
    cdc_send_pack(send_buffer, 4);

    while(length)
    {
        if(length >= 63)
        {
            cdc_send_pack(image, 63);
            image += 63;
            length -= 63;
        }
        else
        {
            cdc_send_pack(image, length);
            length = 0;
        }
    }
}


//-------------------------------------------------------------------------------------------------------------------
//      USB豸ȫ豸ʼ
// ˵     void          
// ز     void
// עϢ
//-------------------------------------------------------------------------------------------------------------------
void usb_cdc_init( void )
{
    // ˵㻺ʼ
    pEP0_RAM_Addr = EP0_DatabufHD;
    pEP1_RAM_Addr = EP1_DatabufHD;
    pEP2_RAM_Addr = EP2_DatabufHD;
    // ʹusbʱ
    USBOTG_RCC_Init();
    system_delay_ms(100);
    // usb豸ʼ
    USBDeviceInit();
    EXTEN->EXTEN_CTR |= EXTEN_USBD_PU_EN;
    // ʹusbж
    NVIC_EnableIRQ(OTG_FS_IRQn);
}
