/*
 * bsp_test.c
 *
 *  Created on: 20231220
 *      Author: www54
 */

#include "bsp_application.h"


void system_status_led_init(void)
{
    gpio_init(RED_LED_PIN, GPO, 1, SPEED_50MHZ | GPO_OPEN_DTAIN);
    gpio_init(GREEN_LED_PIN, GPO, 1, SPEED_50MHZ | GPO_OPEN_DTAIN);
    gpio_init(BLUE_LED_PIN, GPO, 1, SPEED_50MHZ | GPO_OPEN_DTAIN);
}

void open_status_led(led_color ledcolor)
{
    switch (ledcolor) {
        case red:
            gpio_set_level(RED_LED_PIN, 0);
            break;
        case green:
            gpio_set_level(GREEN_LED_PIN, 0);
            break;
        case blue:
            gpio_set_level(BLUE_LED_PIN, 0);
            break;
        case purple:
            gpio_set_level(RED_LED_PIN, 0);
            gpio_set_level(BLUE_LED_PIN, 0);
            break;
        case skybule:
            gpio_set_level(GREEN_LED_PIN, 0);
            gpio_set_level(BLUE_LED_PIN, 0);
            break;
        case white:
            gpio_set_level(RED_LED_PIN, 0);
            gpio_set_level(GREEN_LED_PIN, 0);
            gpio_set_level(BLUE_LED_PIN, 0);
            break;
        default:
            break;
    }
}

void close_status_led(led_color ledcolor)
{
    switch (ledcolor) {
        case red:
            gpio_set_level(RED_LED_PIN, 1);
            break;
        case green:
            gpio_set_level(GREEN_LED_PIN, 1);
            break;
        case blue:
            gpio_set_level(BLUE_LED_PIN, 1);
            break;
        case purple:
            gpio_set_level(RED_LED_PIN, 1);
            gpio_set_level(BLUE_LED_PIN, 1);
            break;
        case skybule:
            gpio_set_level(GREEN_LED_PIN, 1);
            gpio_set_level(BLUE_LED_PIN, 1);
            break;
        case white:
            gpio_set_level(RED_LED_PIN, 1);
            gpio_set_level(GREEN_LED_PIN, 1);
            gpio_set_level(BLUE_LED_PIN, 1);
            break;
        default:
            break;
    }
}

void toggle_status_led(led_color ledcolor)
{
    switch (ledcolor) {
        case red:
            gpio_toggle_level(RED_LED_PIN);
            break;
        case green:
            gpio_toggle_level(GREEN_LED_PIN);
            break;
        case blue:
            gpio_toggle_level(BLUE_LED_PIN);
            break;
        case purple:
            gpio_toggle_level(RED_LED_PIN);
            gpio_toggle_level(BLUE_LED_PIN);
            break;
        case skybule:
            gpio_toggle_level(GREEN_LED_PIN);
            gpio_toggle_level(BLUE_LED_PIN);
            break;
        case white:
            gpio_toggle_level(RED_LED_PIN);
            gpio_toggle_level(GREEN_LED_PIN);
            gpio_toggle_level(BLUE_LED_PIN);
            break;
        default:
            break;
    }
}

void paramUi(void)
{
    //============================ñͷ==================================//
    tft280_set_font(TFT280_8X16_FONT);                                               //ʾС
    tft280_full_area(RGB565_GREEN, 0, MT9V03X_H, MT9V03X_W-1, MT9V03X_H+18);         //ڹ̶ɫ
    tft280_set_color(RGB565_RED, RGB565_GREEN);                                      //
    tft280_show_string(34, MT9V03X_H+1, "PID Param Table");                          //
    tft280_full_area(RGB565_GREEN, MT9V03X_W, 0, 320-1, 18);                         //
    tft280_set_color(RGB565_RED, RGB565_GREEN);                                      //
    tft280_show_string(MT9V03X_W+18, 1, "Message View");                             //
    tft280_draw_line(MT9V03X_W, 0, MT9V03X_W, 240-1, RGB565_GREEN);                  //
    //============================ñͷ==================================//
    tft280_set_font(TFT280_6X8_FONT);
    funcInitStatusDisplay("tft280_init", 0);
    tft280_show_string(0, 232-1, "pushKey: ");
    tft280_show_string(MT9V03X_W-96-1, 232-1, "sysclock: 144MHz");
}

uint16_t display_index = 19;
void funcInitStatusDisplay(const char dat[], uint8_t init_status)
{
    tft280_set_font(TFT280_6X8_FONT);
    tft280_set_color(TFT280_DEFAULT_PENCOLOR, TFT280_DEFAULT_BGCOLOR);
    tft280_show_string(MT9V03X_W+1, display_index, dat);
    if (!init_status) {
        tft280_set_color(TFT280_DEFAULT_PENCOLOR, TFT280_DEFAULT_BGCOLOR);
        switch(tft280_display_font){
            case TFT280_6X8_FONT:
                tft280_show_string(308-1, display_index, "OK");
                break;
            case TFT280_8X16_FONT:
                tft280_show_string(304-1, display_index, "OK");
                break;
            default:
                break;
        }
    } else {
        tft280_set_color(RGB565_RED, TFT280_DEFAULT_BGCOLOR);
        switch(tft280_display_font){
            case TFT280_6X8_FONT:
                tft280_show_string(284-1, display_index, "Failed");
                break;
            case TFT280_8X16_FONT:
                tft280_show_string(272-1, display_index, "Failed");
                break;
            default:
                break;
        }
    }
    switch(tft280_display_font){
        case TFT280_6X8_FONT:
            display_index += 9;
            break;
        case TFT280_8X16_FONT:
            display_index += 17;
            break;
        default:
            break;
    }
}

