/*
 * image.c
 *
 *  Created on: 20231221
 *      Author: www54
 */
#include "image.h"

__attribute__((aligned(4))) uint8 mt9v03x_image_buff1[MT9V03X_H][MT9V03X_W] = {0};
__attribute__((aligned(4))) uint8 mt9v03x_image_buff2[MT9V03X_H][MT9V03X_W] = {0};
uint8 (*image_buff_flag)[MT9V03X_W] = mt9v03x_image_buff1;
uint8 (*image_busy_flag)[MT9V03X_W] = NULL;
volatile uint8 start_image_flag = 0;
uint8_t threshold_array[N] = {0}; // 洢ֵ
uint8_t average_array_index = 0; // ǰֵ

/**
 * Чʴ㷨
 * @param image   ͼ
 * @param col_len г
 * @param row_len г
 * @return ֵ
 */
uint8 otsu_ThresholdCalculate(const uint8 *image, uint16 col_len, uint16 row_len)
{
    uint16 i, j;
    uint32 sum = 0;
    uint32 sumB = 0;
    uint32 wB = 0;
    uint32 wF = 0;
    uint32 mB;
    uint32 mF;
    uint32 max = 0;
    uint32 between = 0;
    uint32 threshold1 = 0;
    uint32 threshold2 = 0;
    uint32 histogram[256] = {0};

    for (i = 0; i < row_len; i++) {
        for (j = 0; j < col_len; j++) {
            histogram[image[i * col_len + j]]++;
        }
    }

    for (i = 0; i < 256; i++) {
        sum += i * histogram[i];
    }

    for (i = 0; i < 256; i++) {
        wB += histogram[i];
        if (wB == 0) {
            continue;
        }
        wF = row_len * col_len - wB;
        if (wF == 0) {
            break;
        }
        sumB += i * histogram[i];
        mB = sumB / wB;
        mF = (sum - sumB) / wF;
        between = wB * wF * (mB - mF) * (mB - mF);
        if (between > max) {
            threshold1 = i;
            if (between > max) {
                threshold2 = i;
            }
            max = between;
        }
    }

    return (threshold1 + threshold2) / 2;
}

/**
 * ֵУƽֵ
 * @param new_threshold µֵ
 * @return ƽֵ
 */
uint8_t add_threshold_and_get_average(uint8_t new_threshold)
{
    uint16_t sum = 0;
    threshold_array[average_array_index] = new_threshold;
    average_array_index = (average_array_index + 1) % N; // ѭ
    for (int i = 0; i < N; i++) {
        sum += threshold_array[i];
    }
    return sum / N; // ƽֵ
}

/**
 * ֵͼ
 * @param image     ͼ
 * @param threshold ֵ
 */
void binarize_image(uint8 *image, uint8_t threshold)
{
    for (int i = 0; i < MT9V03X_H; i++) {
        for (int j = 0; j < MT9V03X_W; j++) {
            if (image[i * MT9V03X_W + j] >= threshold) {
                image[i * MT9V03X_W + j] = 255;
            } else {
                image[i * MT9V03X_W + j] = 0;
            }
        }
    }
}

static void self_dvp_enable(void)
{
    DVP->CR0 |= RB_DVP_ENABLE;
}

void switch_image_buff(void)
{
    if(image_buff_flag == mt9v03x_image_buff1){
        image_buff_flag = mt9v03x_image_buff2;
    }
    else if(image_buff_flag == mt9v03x_image_buff2){
        image_buff_flag = mt9v03x_image_buff1;
    }
    DVP->DMA_BUF0 = (uint32)image_buff_flag;        // DMA addr0
    DVP->DMA_BUF1 = (uint32)image_buff_flag;        // DMA addr1
    self_dvp_enable();
}

void self_dvp_camera_init(uint32 *image0_addr, uint32 *image1_addr, uint16 col_len, uint16 row_len)
{
    RCC_AHBPeriphClockCmd(RCC_AHBPeriph_DVP, ENABLE);

    // ʹ8λɼģʽPCLKزݣHSYNCߵƽЧVSYNCߵƽЧʹDVP
    DVP->CR0 = RB_DVP_D8_MOD | RB_DVP_V_POLAR | RB_DVP_ENABLE;
    // ֡ͼģʽʹDMA
    DVP->CR1 = DVP_RATE_100P | RB_DVP_DMA_EN;

    DVP->ROW_NUM = row_len;                     // rows
    DVP->COL_NUM = col_len;                     // cols

    DVP->DMA_BUF0 = (uint32)image0_addr;        // DMA addr0
    DVP->DMA_BUF1 = (uint32)image1_addr;        // DMA addr1

    // ʹж
    DVP->IER = RB_DVP_IE_FRM_DONE;              // ֡ж

    interrupt_set_priority(DVP_IRQn, 0x0);
    interrupt_enable(DVP_IRQn);
}

//-------------------------------------------------------------------------------------------------------------------
//      MT9V03X ͷʼ
// ˵     void
// ز     uint8           0-ɹ x-ʧ
// ʹʾ     mt9v03x_init();
// עϢ
//-------------------------------------------------------------------------------------------------------------------
uint8 self_mt9v03x_init(void)
{

    uint8 return_state  = 0;

    do
    {
        set_camera_type(CAMERA_GRAYSCALE, NULL, mt9v03x_dvp_handler);
        if(mt9v03x_sccb_init())
        {
            set_camera_type(CAMERA_GRAYSCALE, mt9v03x_uart_handler, mt9v03x_dvp_handler);
            return_state = mt9v03x_uart_init();
        }

        if(!return_state)
        {
           // DVPųʼ
            dvp_gpio_init(
                MT9V03X_D0_PIN, MT9V03X_D1_PIN, MT9V03X_D2_PIN, MT9V03X_D3_PIN,
                MT9V03X_D4_PIN, MT9V03X_D5_PIN, MT9V03X_D6_PIN, MT9V03X_D7_PIN,
                MT9V03X_PCLK_PIN, MT9V03X_VSY_PIN, MT9V03X_HERF_PIN);

            // DVPӿڳʼ
            self_dvp_camera_init((uint32 *)(image_buff_flag), (uint32 *)(image_buff_flag), MT9V03X_W*MT9V03X_H, MT9V03X_H);
            break;
        }
        set_camera_type(NO_CAMERE, NULL, NULL);
    }while(0);

    if (!return_state) {
        //ͷʼɹͼպͿƶʱж
        timer_1ms_interrupt_init();         //tim61msʱж
    }
    if (!return_state) {
        close_status_led(red);
    }
    else {
        open_status_led(red);
    }

    funcInitStatusDisplay(__func__, return_state);

    return return_state;
}

