/*
 * tft280_ili9341.h
 *
 *  Created on: 20231219
 *      Author: www54
 */

#ifndef TFT280_ILI9341_H_
#define TFT280_ILI9341_H_

/*********************************************************************************************************************
* ߶壺
*                   ------------------------------------
*                   ģܽ             Ƭܽ
*                   SCL                  鿴 zf_device_TFT280.h  TFT280_SCL_PIN 궨
*                   SDA                  鿴 zf_device_TFT280.h  TFT280_SDA_PIN 궨
*                   RES                  鿴 zf_device_TFT280.h  TFT280_RES_PIN 궨
*                   DC                   鿴 zf_device_TFT280.h  TFT280_DC_PIN 궨
*                   CS                   鿴 zf_device_TFT280.h  TFT280_CS_PIN 궨
*                   BL                   鿴 zf_device_TFT280.h  TFT280_BL_PIN 궨
*                   VCC                 3.3VԴ
*                   GND                 Դ
*                   ֱ320*240
*                   ------------------------------------
********************************************************************************************************************/

#include "zf_common_typedef.h"

extern uint16 pix_color;

#define TFT280_USE_SOFT_SPI             (0)                                     // ĬʹӲ SPI ʽ ʹӲ SPI ʽ
#if TFT280_USE_SOFT_SPI                                                         //  ɫĲȷ ɫҵľûõ
//==================================================== SPI ====================================================
#define TFT280_SOFT_SPI_DELAY           (1 )                                    //  SPI ʱʱ ֵԽС SPI ͨԽ
#define TFT280_SCL_PIN                  (B13)                                   //  SPI SCK 
#define TFT280_SDA_PIN                  (B15)                                   //  SPI MOSI 
//==================================================== SPI ====================================================
#else
//====================================================Ӳ SPI ====================================================
#define TFT280_SPI_SPEED                (72 * 1000 * 1000)                      // Ӳ SPI 
#define TFT280_SPI                      (SPI_1)                                 // Ӳ SPI 
#define TFT280_SCL_PIN                  (SPI1_MAP0_SCK_A5)                     // Ӳ SPI SCK 
#define TFT280_SDA_PIN                  (SPI1_MAP0_MOSI_A7)                    // Ӳ SPI MOSI 
//====================================================Ӳ SPI ====================================================
#endif
//====================================================SPI DMA====================================================
#define TFT280_SPI_DMA                  (1)
#define TFT280_SPI_DMA_BUFF_SIZE        (1)
#define TFT280_SPI_DMA_TX_DATA_ADDR     (&pix_color)
//#define TFT280_SPI_DMA_TX_CH            (DMA1_Channel3)//SPI1TXͨӦDMA
//#define TFT280_SPI_DMA_TX_CH            (DMA1_Channel5)//SPI2TXͨӦDMA
#define TFT280_SPI_DMA_TX_CH            (DMA2_Channel2)//SPI3TXͨӦDMA

//====================================================SPI DMA====================================================
#define TFT280_RES_PIN                  (A11)                                    // ҺλŶ
#define TFT280_DC_PIN                   (A10)                                    // ҺλŶ
#define TFT280_CS_PIN                   (A4)                                    // CS Ƭѡ
#define TFT280_BL_PIN                   (A9)                                    // ҺŶ

#define TFT280_DEFAULT_DISPLAY_DIR      (TFT280_CROSSWISE)                        // Ĭϵʾ
#define TFT280_DEFAULT_PENCOLOR         (RGB565_PURPLE)                            // ĬϵĻɫ
#define TFT280_DEFAULT_BGCOLOR          (RGB565_WHITE)                          // Ĭϵıɫ
#define TFT280_DEFAULT_DISPLAY_FONT     (TFT280_8X16_FONT)                      // Ĭϵģʽ

#define TFT280_DC(x)                    ((x) ? (gpio_high(TFT280_DC_PIN)) : (gpio_low(TFT280_DC_PIN)))
#define TFT280_RST(x)                   ((x) ? (gpio_high(TFT280_RES_PIN)) : (gpio_low(TFT280_RES_PIN)))
#define TFT280_CS(x)                    ((x) ? (gpio_high(TFT280_CS_PIN)) : (gpio_low(TFT280_CS_PIN)))
#define TFT280_BLK(x)                   ((x) ? (gpio_high(TFT280_BL_PIN)) : (gpio_low(TFT280_BL_PIN)))

#define TFT280_X_MAX 320
#define TFT280_Y_MAX 240

typedef enum
{
    TFT280_PORTAIT                      = 0,                                    // ģʽ
    TFT280_PORTAIT_180                  = 1,                                    // ģʽ  ת180
    TFT280_CROSSWISE                    = 2,                                    // ģʽ
    TFT280_CROSSWISE_180                = 3,                                    // ģʽ  ת180
}tft280_dir_enum;

typedef enum
{
    TFT280_6X8_FONT                     = 0,                                    // 6x8      
    TFT280_8X16_FONT                    = 1,                                    // 8x16     
    TFT280_16X16_FONT                   = 2,                                    // 16x16     Ŀǰ֧
}tft280_font_size_enum;

extern tft280_font_size_enum    tft280_display_font;

void    tft280_clear                    (void);
void    tft280_full                     (const uint16 color);
void    tft280_full_area                (const uint16 color, uint16 x1, uint16 y1, uint16 x2, uint16 y2);
void    tft280_set_dir                  (tft280_dir_enum dir);
void    tft280_set_font                 (tft280_font_size_enum font);
void    tft280_set_color                (const uint16 pen, const  uint16 bgcolor);
void    tft280_set_region               (uint16 x1, uint16 y1, uint16 x2, uint16 y2);
void    tft280_draw_point               (uint16 x, uint16 y, const uint16 color);
void    tft280_draw_line                (uint16 x_start, uint16 y_start, uint16 x_end, uint16 y_end, const uint16 color);

void    tft280_show_char                (uint16 x, uint16 y, const char dat);
void    tft280_show_string              (uint16 x, uint16 y, const char dat[]);
void    tft280_show_int                 (uint16 x,uint16 y, const int32 dat, uint8 num);
void    tft280_show_uint                (uint16 x,uint16 y, const uint32 dat, uint8 num);
void    tft280_show_float               (uint16 x,uint16 y, const double dat, uint8 num, uint8 pointnum);

void    tft280_show_binary_image        (uint16 x, uint16 y, const uint8 *image, uint16 width, uint16 height, uint16 dis_width, uint16 dis_height);
void    tft280_show_gray_image          (uint16 x, uint16 y, const uint8 *image, uint16 width, uint16 height, uint16 dis_width, uint16 dis_height, uint8 threshold);
void    tft280_show_rgb565_image        (uint16 x, uint16 y, const uint16 *image, uint16 width, uint16 height, uint16 dis_width, uint16 dis_height, uint8 color_mode);

void    tft280_show_wave                (uint16 x, uint16 y, const uint16 *wave, uint16 width, uint16 value_max, uint16 dis_width, uint16 dis_value_max);
void    tft280_show_chinese             (uint16 x, uint16 y, uint8 size, const uint8 *chinese_buffer, uint8 number, const uint16 color);

//-------------------------------------------------------------------------------------------------------------------
//      TFT280 ʾСͼ
// ˵     p               ͼ
// ˵     width           ʾ
// ˵     height          ʾ߶
// ز     void
// ʹʾ     TFT280_displayimage7725(ov7725_image_binary[0], 80, 60);
// עϢ
//-------------------------------------------------------------------------------------------------------------------
#define tft280_displayimage7725(p, width, height)       (tft280_show_binary_image(0, 0, (p), OV7725_W, OV7725_H, (width), (height)))

//-------------------------------------------------------------------------------------------------------------------
//      TFT280 ʾͼ ֵ ʾҶͼ
// ˵     p               ͼ
// ˵     width           ʾ
// ˵     height          ʾ߶
// ز     void
// ʹʾ     TFT280_displayimage03x(mt9v03x_image[0], 94, 60);
// עϢ     Ҫʾֵͼȥ TFT280_show_gray_image 
//-------------------------------------------------------------------------------------------------------------------
#define tft280_displayimage03x(p, width, height, threshold)        (tft280_show_gray_image(0, 0, (p), MT9V03X_W, MT9V03X_H, (width), (height), threshold))

//-------------------------------------------------------------------------------------------------------------------
//      TFT280 ʾͫͼ
// ˵     p               ͼ
// ˵     width           ʾ
// ˵     height          ʾ߶
// ز     void
// ʹʾ     TFT280_displayimage8660(scc8660_image[0], 80, 60);
// עϢ
//-------------------------------------------------------------------------------------------------------------------
#define tft280_displayimage8660(p, width, height)       (tft280_show_rgb565_image(0, 0, (p), SCC8660_W, SCC8660_H, (width), (height), 1))
//-------------------------------------------------------------------------------------------------------------------
//      TFT280 ʾͼ ֵ ʾҶͼ
// ˵     p               ͼ
// ˵     width           ʾ
// ˵     height          ʾ߶
// ز     void
// ʹʾ     tft280_display_image(mt9v03x_image[0], 94, 60);
// עϢ     Ҫʾֵͼȥ TFT280_show_gray_image 
//-------------------------------------------------------------------------------------------------------------------
#define tft280_spi_dma_show_image() tft280_display_image(0, 0, image_busy_flag[0], MT9V03X_W, MT9V03X_H, MT9V03X_W, MT9V03X_H, 0)

void tft280_display_image(uint16 x, uint16 y, const uint8 *image, uint16 width, uint16 height, uint16 dis_width, uint16 dis_height, uint8 threshold);
void    switch_spi_dma_data_addr        (void);
void    tft280_init                     (void);

#endif /* TFT280_ILI9341_H_ */
